%Magic Tournament Model
clc, close all, clear all
tic
%This is what we edit
tournaments=10000;
pointstourn=zeros(1,tournaments);




players=300;
rounds=8;
DeckA=2/5;
DeckB=1/3;
AvsB=1;
AvsC=0;
BvsC=1;



%Let's start with a match lookup table
Matches=[.5 AvsB AvsC;1-AvsB .5 BvsC;1-AvsC 1-BvsC .5];

%Now let's creat the metagame based on what we inputted
DeckC=1-(DeckA+DeckB);
Decks=ones(players,1);
playersv=(1:1:players)';
%This is super ineffeicent, but I don't care
for i=floor(players*DeckA)+1:players
    if i/players>DeckA+DeckB
        Decks(i)=3;
    else
        Decks(i)=2;
    end
end
nDecks=max(Decks);
top8count=zeros(1,nDecks);
top4count=zeros(1,nDecks);
top2count=zeros(1,nDecks);
wincount=zeros(1,nDecks);
for t=1:tournaments
    %Now we want to create a round 1 pairings vector, once again the thing I
    %care least about is code effeciency
    pairings=zeros(players,rounds);
    points = zeros(players,rounds);
    for i=1:rounds
        %For each round we need to group players by record and then pair them
        lplayers = playersv;
        lpoints=points;
        %Group people with similar records
        for j=1:i
            loopgroup = [];
            loopgroup=find(sum(lpoints,2)==(j-1)*3);
            if size(loopgroup)/2~=floor(size(loopgroup)/2);
                [loopgroup, lpoints] = oddplayers(loopgroup,lplayers, lpoints, j);
            end
            pairings(loopgroup,i)=pair(loopgroup);
        end
        lpoints = [];
        points(:,i) = winner(Decks, pairings(:,i), Matches);
    end
    
    %Player Ranking Time - Tiebreakers and everything
    Top8 = PlayerRank(points, pairings);
    %Let's play the top 8s
    Winners = runtop8(Top8, Decks, Matches);
    windecks=Decks([Top8' Winners]);
    for i=1:nDecks
        top8count(i)=top8count(i)+sum(windecks(1:8)==i);
        top4count(i)=top4count(i)+sum(windecks(9:12)==i);
        top2count(i)=top2count(i)+sum(windecks(13:14)==i);
        wincount(i)=wincount(i)+sum(windecks(15)==i);
    end
    
end
top8count=top8count/(8*tournaments)
top4count=top4count/(4*tournaments)
top2count=top2count/(2*tournaments)
wincount=wincount/tournaments


toc